# coding: utf-8
# rubocop:disable Metrics/LineLength

require 'clamp'
require 'gaptool_client/commands'

module Gaptool
  class MainCommand < Clamp::Command
    subcommand 'info', 'Displays information about nodes', InfoCommand
    subcommand 'init', 'Create new application cluster', InitCommand
    subcommand 'terminate', 'Terminate instance', TerminateCommand
    subcommand 'ssh-config', 'Configure ssh', SSHConfigCommand
    subcommand 'ssh', 'ssh to cluster host', SSHCommand
    subcommand 'set', 'update properties for a node', SetCommand
    subcommand 'chefrun', 'chefrun on a resource pool', ChefrunCommand
    subcommand 'deploy', 'deploy on an application', DeployCommand
    subcommand 'rehash', 'Regenerate all host metadata. KNOW WHAT THIS DOES BEFORE RUNNING IT', RehashCommand
    subcommand 'runcmd', 'Run command on instance', RuncmdCommand
    subcommand 'runscript', 'Run command on instance', RunScriptCommand
    subcommand 'scp', 'Copy file to-from instance(s)', ScpCommand
    subcommand 'version', 'Show version', VersionCommand
  end
end
